#!/usr/bin/env python3
# script to remove the "other-features" section from a choices file
# along with any references to those features in the lexicon

import sys
import re



FEAT_NAME_RE = re.compile('feat[ure]*\d+_name=(.*)')
in_other_feats = 0
feat_names = []
delete_prefs = []
for l in sys.stdin.readlines():
  if l.find('section=other-features') != -1:    
    in_other_feats = 1
  elif in_other_feats:
    if l.find('section=') != -1:
      in_other_feats =0
      print(l,end="")
    else: #read a feature name, delete any lines in here
      r =  FEAT_NAME_RE.findall(l)
      if r and not r[0] in feat_names: feat_names.append(r[0])
  else:
    # need to delete any refs to these feats defined in other sections 
    r = FEAT_NAME_RE.findall(l)
    if r and r[0] in feat_names:
      p = l.split('_name')[0]
      if not p in delete_prefs: delete_prefs.append(p)

    skip = 0
    for p in delete_prefs:
      if l.find(p) != -1: skip=1 
    if not skip:
      print(l,end="")
