#!/bin/bash

# Create the data splits for Chintang

if [ -z "$AGGREGATIONHOME" ]; then
  echo "AGGREGATIONHOME is not set. Attempting to locate." >&2
  curdir=$( cd `dirname "$0"`/../../.. && pwd)
  if [ -z "$curdir" ]; then
    echo "AGGREGATIONHOME directory could not be found. Exiting." >&2
    exit 1
  fi
  AGGREGATIONHOME="$curdir"
fi

ctndir="$AGGREGATIONHOME/data/ctn"
srcdir="$AGGREGATIONHOME/src/data"

# First filter to get items with \mph, \mgl, \eng, and \id lines. The
# \id tier is not necessary for processing, but its presence indicates
# higher-quality alignments.
echo "Splitting IGTs with \\mph, \\mgl, \\eng, and \\id" >&2
for f in `find "$ctndir/download/txt/" -name *.txt`; do
  cat "$f" \
    | "$srcdir"/toolbox-filter.sh "\\\\mph" "\\\\mgl" "\\\\eng" "\\\\id" \
    | "$srcdir"/toolbox-split.py -r -a \
        -s 0.1 "test" -s 0.1 "dev" -s 0.8 "train"
done

echo "Splitting IGTs with \\mph, \\mgl, \\eng, and without \\id" >&2
for f in `find "$ctndir/download/txt/" -name *.txt`; do
  cat "$f" \
    | "$srcdir"/toolbox-filter.sh "\\\\mph" "\\\\mgl" "\\\\eng" ! "\\\\id" \
    | "$srcdir"/toolbox-split.py -r -a \
        -s 0.1 "test-no-id" -s 0.1 "dev-no-id" -s 0.8 "train-no-id"
done
