#!/usr/bin/env python3

# usage: toolbox-to-tsdb-item.py < toolbox-data > item
# future usage: toolbox-to-tsdb-item.py RELATIONS < toolbox-data > item

import sys
from collections import OrderedDict
import json
import re
from datetime import datetime
#import tsdb_profile as tsdb

#relations = sys.argv[1]
#
#item:
#  i-id :integer :key
#  i-origin :string
#  i-register :string
#  i-format :string
#  i-difficulty :integer
#  i-category :string
#  i-input :string
#  i-tokens :string
#  i-gloss :string
#  i-translation :string
#  i-wf :integer
#  i-length :integer
#  i-comment :string
#  i-author :string
#  i-date :date

respace_re = re.compile(r'\s+')
reattach_re = re.compile(r'\s*-\s*')
def respace_mph(s):
    s = respace_re.sub(' ', s)
    s = reattach_re.sub('-', s)
    return s

def escape(s):
    return s.replace('\\','\\\\').replace('@','\\s').replace('\n','\\n')

inst = {}
i = 10
for line in map(str.strip, sys.stdin):
    if line == '' and len(inst) > 0:
        # for now this is hardcoded. In the future try to use a module
        # for writing the [incr tsdb()] profile (e.g. from pyDelphin)
        mph = respace_mph(inst['mph'])
        print('{}@@@@-1@@{}@@@@1@{}@{}@@{}'
              .format(i, escape(mph), len(mph.split()),
                      escape('\\ref {}\n\\mgl {}\n\\eng {}'
                             .format(inst['ref'], inst['mgl'], inst['eng'])),
                      str(datetime.today().date())
              )
        )
        i += 10
        inst = {}
    elif line != '':
        try:
            key, rest = line.split(None, 1) # e.g. ['\tx', 'blah blah blah']
        except ValueError:
            key = line.strip()
            rest = ''
        inst[key.lstrip('\\')] = rest

