#!/bin/bash

if [ -z "$AGGREGATIONHOME" ]; then
  echo "AGGREGATIONHOME is not set. Attempting to locate." >&2
  reldir=$( cd `dirname "$0"`/../../.. && pwd)
  if [ -z "$reldir" ]; then
    echo "AGGREGATIONHOME directory could not be found. Exiting." >&2
    exit 1
  fi
  AGGREGATIONHOME="$reldir"
fi

infile="$1"
outdir="$2"

python3.2 "$AGGREGATIONHOME/src/xigt/doc-split.py" "$infile" "$outdir"
python3.2 "$AGGREGATIONHOME/src/xigt/query.py" -s "$outdir"/*.xml > "$outdir/summary.txt"
python3.2 "$AGGREGATIONHOME/src/xigt/query.py" -l "$outdir"/*.xml > "$outdir/languages.txt"
