#!/bin/bash

if [ -z "$AGGREGATIONHOME" ]; then
  echo "AGGREGATIONHOME is not set. Attempting to locate." >&2
  reldir=$( cd `dirname "$0"`/../../.. && pwd)
  if [ -z "$reldir" ]; then
    echo "AGGREGATIONHOME directory could not be found. Exiting." >&2
    exit 1
  fi
  AGGREGATIONHOME="$reldir"
fi

export LANG=en_US.UTF-8
ODINDIR="/projects/igt_annot/fxia/lang_id/stage2_fei/9_2/"

[ "$#" -eq 2 ] || { echo "usage: import-all.sh [-l|-d] OUTDIR" >&2; exit 1; }
[ "$1" == "-l" ] || [ "$1" == "-d" ] || {
    echo "First arg must be -l or -d";
    exit 1;
}

OUTDIR="$2"
mkdir -p "$OUTDIR"

CURDIR="$AGGREGATIONHOME/src/data/odin"

# no longer reformatting blocks
#| "$AGGREGATIONHOME/src/data/odin/"get-igt-blocks.sh \
find "$ODINDIR" -name *.check -exec iconv -f iso-8859-1 -t UTF-8 {} \; \
| "$CURDIR/xigt-import-by.sh" "$1" -ac -vv -o "$OUTDIR"
python3.2 "$AGGREGATIONHOME/src/xigt/query.py" -s "$OUTDIR/"*.xml > "$OUTDIR/summary.txt"
python3.2 "$AGGREGATIONHOME/src/xigt/query.py" -l "$OUTDIR/"*.xml > "$OUTDIR/languages.txt"

