#!/bin/bash

if [ -z "$AGGREGATIONHOME" ]; then
  echo "AGGREGATIONHOME is not set. Attempting to locate." >&2
  reldir=$( cd `dirname "$0"`/../../.. && pwd)
  if [ -z "$reldir" ]; then
    echo "AGGREGATIONHOME directory could not be found. Exiting." >&2
    exit 1
  fi
  AGGREGATIONHOME="$reldir"
fi

export LANG=en_US.UTF-8
ODINDIR="/projects/igt_annot/fxia/lang_id/stage2_fei/9_2/"

[ "$#" -eq 1 ] || { echo "usage: import-all.sh OUTDIR" >&2; exit 1; }

OUTDIR="$1"
mkdir -p "$OUTDIR"

CURDIR="$AGGREGATIONHOME/src/data/odin"

# no longer reformatting blocks
#| "$AGGREGATIONHOME/src/data/odin/"get-igt-blocks.sh \
find "$ODINDIR" -name *.check -exec iconv -f iso-8859-1 -t UTF-8 {} \; \
| "$CURDIR/xigt-import.sh" -ac -vv > "$OUTDIR/odin.xml"
python3.2 "$AGGREGATIONHOME/src/xigt/query.py" -S "$OUTDIR/odin.xml" > "$OUTDIR/summary.txt"
python3.2 "$AGGREGATIONHOME/src/xigt/query.py" -L "$OUTDIR/odin.xml" > "$OUTDIR/languages.txt"

#mkdir "$OUTDIR/by-lang" "$OUTDIR/by-doc-id"
#"$CURDIR/import-all-by.sh" -l "$OUTDIR/by-lang"
#"$CURDIR/import-all-by.sh" -d "$OUTDIR/by-doc-id"
