#!/bin/bash

usage() {
    echo "usage: filter-toolbox.sh [PATTERN|! PATTERN].." >&2
    echo "  Returns only items matching the regex PATTERN, or if ! appears" >&2
    echo "  before PATTERN, items not matching the regex" >&2
    echo "example:" >&2
    echo "  Get items with \\ref lines but not \\id lines:" >&2
    echo "  filter-toolbox.sh \"\\\\\\\\ref\" ! \"\\\\\\\\id\" < infile" >&2
}

[ "$#" -lt 1 ] && { usage; exit 1; }

while [ "$#" -gt 0 ]; do
    if [ "$1" == "!" ]; then
        patterns="/$2 *\\S/d;$patterns"
        shift 2
    else
        patterns="/$1 *\\S/!d;$patterns"
        shift
    fi
done
#for p in "$@"; do
#    patterns="/$p *\\S/!d;$patterns"
#done

sed -r "/./{H;$!d;}; x; $patterns"
