<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" 
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/text">
    <html>
      <head><title/><style type="text/css">table{border:1px solid black;margin:10px}td{padding:5px}</style></head>
      <body>
      <ol>
        <xsl:apply-templates select="body/phrases"/>
      </ol>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="phrases">
    <xsl:for-each select="phrase">
    <xsl:variable name="ph_id" select="@ph_id"/>
    <xsl:variable name="mcount" select="count(/text/body/morphemes/phrase[@phrase_ref=$ph_id]/morph)"/>
    <li><table><colgroup><col span="1" style="background:grey" align="right"/></colgroup>
       <tr><td>text:</td><xsl:element name="td">
           <xsl:attribute name="colspan"><xsl:value-of select="$mcount"/></xsl:attribute>
           <xsl:value-of select="plaintext" />
           </xsl:element>
       </tr>
       <tr><td>words:</td><xsl:for-each select="word">
           <xsl:variable name="wd_id" select="@wd_id"/>
           <xsl:variable name="wcount" select="count(/text/body/morphemes/phrase[@phrase_ref=$ph_id]//morph[contains(@morph_id,$wd_id)])"/>
           <xsl:element name="td">
           <xsl:attribute name="colspan"><xsl:value-of select="$wcount"/></xsl:attribute>
           <xsl:value-of select="@text" />
           </xsl:element>
           </xsl:for-each>
       </tr>
       <tr><td>morphs:</td><xsl:for-each select="/text/body/morphemes/phrase[@phrase_ref=$ph_id]/morph">
           <td><xsl:value-of select="@text"/></td>
           </xsl:for-each>
       </tr>
       <tr><td>glosses:</td><xsl:for-each select="/text/body/gloss/phrase[@phrase_ref=$ph_id]/gls">
           <td><xsl:value-of select="@text"/></td>
           </xsl:for-each>
       </tr>
       <tr><td>class:</td><xsl:for-each select="/text/body/wordclass/phrase[@phrase_ref=$ph_id]/cls">
           <td><xsl:value-of select="@text"/></td>
           </xsl:for-each>
       </tr>
       <tr><td>POS:</td><xsl:for-each select="/text/body/postags/phrase[@phrase_ref=$ph_id]/pos">
           <td><xsl:value-of select="@text"/></td>
           </xsl:for-each>
       </tr>
       <tr><td>status:</td><xsl:for-each select="/text/body/status/phrase[@phrase_ref=$ph_id]/gs">
           <td><xsl:value-of select="@type"/></td>
           </xsl:for-each>
       </tr>
       <tr><td>trans:</td><xsl:element name="td">
           <xsl:attribute name="colspan"><xsl:value-of select="$mcount"/></xsl:attribute>
           <xsl:value-of select="/text/body/translations/phrase[@phrase_ref=$ph_id]/trans"/>
           </xsl:element>
       </tr>
    </table></li>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
