#!/usr/bin/env perl


## created on 12/21/05

## Purpose: indent a ttree from the treebank
##          This code will not check whether the input ttrees are valid or not.

## to run:
##    cat ttree | $0 > sent_file

## The input ttree is on one line or multiple lines.

## We assume
##  -  the first line of a ttree starts with "(\s*(..."
##  -  other lines of a ttree starts with "(" or ")"
##  -  lines not starting with "(" are ignored.

## Note: I have run it on GB code with no problem.


use strict;

use indent_ttree;

my $ttree_num = getAndIndentTtrees();

print STDERR "Finish indenting $ttree_num ttrees\n";

1;


#####################################################
## return the num of ttrees
sub getAndIndentTtrees {
    my $str = "";
    my $line_num = 0;
    my $display_num = 0;

    if(@ARGV > 0){
       $display_num = $ARGV[0];
    }

    while(<STDIN>){
	chomp;
	$line_num ++;

	if(/^\s*$/){
	    print "$_\n";
	    next;
	}

	if(!/^\s*\(/ && !/^\s*\)/){
	    print STDERR "Warning line $line_num: +$_+ is not a ttree line.\n";
	    print "$_\n";
	    next;
	}

	if(/^\(/){
	    ## the beginning of a ttree
	    if($str ne ""){
		$ttree_num ++;
                if($display_num){
                  print "\#\# sent_num=$ttree_num\n\n";
                }
		print indentTtree($str);
		print "\n";
	    }
	    $str = $_;
	}else{
	    $str .= " " . $_;
	}
    }

    if($str ne ""){
        $ttree_num ++;
        if($display_num){
            print "\#\# sent_num=$ttree_num\n\n";
        }

	print indentTtree($str);
	print "\n";
    }

    return $ttree_num;
}

