#!/usr/bin/env perl


## created on 12/21/05

## Purpose: indent a ttree from the treebank
##          This code will not check whether the input ttrees are valid or not.

## to run:
##    cat ttree | $0 > sent_file

## The input ttree is on one line or multiple lines.

## We assume
##  -  the first line of a ttree starts with "(\s*(..."
##  -  other lines of a ttree starts with "(" or ")"
##  -  lines not starting with "(" are ignored.

## Note: I have run it on GB code with no problem.


use strict;



#####################################################
## ttree is in one line.
## return the indent_ttree_str;
sub indentTtree {
    my ($ttree_str) = @_;
    my $return_str = "";
    my $cur_line = "";

    my $cur_level = 0;
    my $max_valid_level = -1; ## the level where $level_pos[] is available

    my @level_pos = ();
    my $cur_pos = 0;

    $ttree_str =~ s/\(/ \( /g;
    $ttree_str =~ s/\)/ \) /g;
    $ttree_str =~ s/^\s+//;
    $ttree_str =~ s/\s+$//;

    my @parts = split(/\s+/, $ttree_str);

    my $prev_is_left_brack = 0;
    foreach my $part (@parts){


	if($part eq "\("){
	    if($cur_level > $max_valid_level){
		## 1st time to come to that level
		setLevelPos($cur_level, $cur_pos, \@level_pos);
		$max_valid_level ++;
	    }else{
		## not the first time to be at this level
		$return_str .= $cur_line . "\n";
		$cur_pos = $level_pos[$cur_level];
		$cur_line = blankChars($cur_pos);
		$max_valid_level = $cur_level;
	    }

	    $cur_line .= $part;
	    $cur_pos ++;

	    $cur_level ++;
	    $prev_is_left_brack = 1;
	    next;
	}		
		
	if($part eq "\)"){
	    $cur_level --;
	    $cur_line .= $part;
	    $cur_pos ++;
	    $prev_is_left_brack = 0;
	    next;
	}

	$cur_line .= $part;
	$cur_pos += length($part);

	if($prev_is_left_brack){
	    $cur_line .= " ";
	    $cur_pos ++;
	}

	$prev_is_left_brack = 0;
    }

    $return_str .= $cur_line;
    if($cur_level != 0){
	print STDERR "warning: the ttree ends with level=$cur_level. The ttree_str is:\n+$ttree_str+\nThe return_str is:\n+$return_str+\n";
    }

    return $return_str;
}


sub blankChars {
    my ($n) = @_;

    my $str = "";
    for(my $i=0; $i<$n; $i++){
	$str .= " ";
    }

    return $str;
}

sub setLevelPos {
    my ($level, $pos, $array_ptr) = @_;
    my $array_size = scalar @$array_ptr;
    if($level >= $array_size){
	for(my $i=0; $i<$level - $array_size+1; $i++){
	    push(@$array_ptr, 0);
	}
    }
    $array_ptr->[$level] = $pos;
}

1;

