#!/usr/bin/env perl

## purpose: run Bikel's parser

## usage: $0 input_file output_file

## input_fie is tokenized sent. One sent per line.


use strict;

my $dir = "~/NLP_tools/parsers/dbparser/RAW/dbparser";
my $param = "$dir/settings/collins.properties";
my $obj = "~/NLP_tools/parsers/dbparser/Fei/wsj-02-21.obj.gz";
my $parser = "$dir/bin/parse";

if(@ARGV != 2){
    die "usage: $0 input_file output_file\n";
}

my $input_file = $ARGV[0];
my $output_file = $ARGV[1];

my $parser_input_file = "/tmp/tmp.db_parser";
my $parser_output_file = "$parser_input_file.parsed";

#### converting
my $cmd = "cat $input_file | ba205.exec > $parser_input_file";
print STDERR "$cmd\n";
system($cmd);

if($?){
    die "$cmd failed\n";
}


### parsing
$cmd = "$parser 400 $param $obj $parser_input_file";
print STDERR "$cmd\n";
system($cmd);
if($?){
    die "$cmd failed\n";
}

### renaming

$cmd = "mv $parser_output_file $output_file";
system($cmd);

$cmd = "mv $parser_input_file $output_file.sent";
system($cmd);

if($?){
    die "$cmd failed\n";
}

print STDERR "succeed: $output_file is created\n";

