#!/usr/bin/env perl

## purpose: run Charniak's parser

## usage: $0 input_file output_file

## input_fie is tokenized sent. One sent per line.


use strict;

my $param = "/projects/grants/aggregation/fxia/fei_chains_data/para_files/nlparser/Fei/DATA/EN/";
my $parser = "/projects/grants/aggregation/fxia/fei_chains_data/para_files/nlparser/RAW/parser05July11/PARSE/parseIt";

if(@ARGV != 2){
    die "usage: $0 input_file output_file\n";
}

my $input_file = $ARGV[0];
my $output_file = $ARGV[1];

my $parser_input_file = "$output_file.tmp";

#### converting
my $cmd = "cat $input_file | ea205.exec > $parser_input_file";
print STDERR "$cmd\n";
system($cmd);

if($?){
    die "$cmd failed\n";
}


### parsing
# $cmd = "cat $parser_input_file | $parser $param -K -T210 -l40 -C | eb205.exec > $output_file";
# JDC 22 sept 2014: removed -l40 option, added 2>&1 to parser call output
# -l40 to parser limits to sents of length <= 40, some of our data has longer sentences
# piped stderr to stdout so that eb205.exec can hear complaints from charniak 
$cmd = "cat $parser_input_file | $parser $param -K -T210 -C 2>&1 | eb205.exec > $output_file";

print STDERR "$cmd\n";
system($cmd);
if($?){
    die "$cmd failed on parse step\n";
}

### renaming

$cmd = "mv $parser_input_file $output_file.sent";
system($cmd);

if($?){
    die "$cmd failed on move step\n";
}

print STDERR "succeed: $output_file is created\n";

