#!/usr/bin/env perl

use strict;

use Class::Struct;

my $INTERNAL_NODE = 1;
my $LEAF_NODE = 2;

my $LEFT_DIRECTION = 0;
my $RIGHT_DIRECTION = 1;

use ttree;

##################################################### main code
my $cnt = 0;
my $valid = 0;

die "usage: $0 head_table default_direction\n" unless (@ARGV == 2);

my $default_direction = $LEFT_DIRECTION;

if($ARGV[1] =~ /right/i){
   $default_direction = $RIGHT_DIRECTION;
}

my $head_table = new HeadTable;

open(my $fp, "$ARGV[0]") or die "cannot open $ARGV[0]\n";

my $cnt = read_head_table($fp, $head_table);

## print_head_table($head_table);

open(my $fp, ">/tmp/a4") or die "cannot create /tmp/a4\n";

while(<STDIN>){
    chomp;

    $cnt ++;

    my $ttree_str = $_;

    ### step 1: read ttree
    my $ttree = new Ttree;
    
    my $suc = str_to_ttree($ttree_str, $ttree);

    if(!$suc){
	print STDERR "str_to_ttree failed: +$ttree_str\n";
	next;
    }

    ### step 2: find heads
    $suc = find_heads_in_ttree($ttree, $head_table, $default_direction);
    if(!$suc){
      print STDERR "find_heads failed\n";
    }

    ### step 3: print out the string
    my $new_str;
    $suc = ttree_to_str($ttree, \$new_str, 1);

    if($suc){
	print STDOUT "$new_str\n";
	$valid ++;
    }else{
	print STDERR "ttree_to_str failed: +$ttree_str\n";
    }

    ### step 4: print out the dependency tree

    ## print_dependency_tree($fp, $ttree);
}

close($fp);

print STDERR "cnt=$cnt, valid=$valid\n";

1;

