#!/usr/bin/env python3
# this script runs after the other aggregation stuff to cleanup known
# issues with the output of mom

import sys
import re

##
## old script (commented out) would remove features which clobber case names
## new script (below) just gets rid of all the mom features

#casename_re = re.compile('case\d+_name=(\w+)|case-name=(\w+)')
#featname_re = re.compile('feature\d+_name=(\w+)|feature\d+_value\d+_supertype\d+_name=(\w+)')
#
#
#lines = open(sys.argv[1]).readlines()
#case_names=[]
#
## issue 1--change backslashes in feature names for hyphens
#
#for i,l in enumerate(lines):
#  # while we're in here, let's get the case names info for step 2
#  m = casename_re.search(l)
#  if m:
#    case_names.append(l.split('=')[1].strip())
#  lines[i] = l.replace('\\','-')
#
## issue 2--mom feature names clobbering case names
## any feature names which clobber case names have to be changed
#for i,l in enumerate(lines): 
#  m = featname_re.search(l)
#  if m:
#    if m.group(1) in case_names or m.group(2) in case_names:
#      k,v = l.split('=')
#      lines[i]='='.join([k,v.strip()+"-mom\n"])
#
## done, output
#for l in lines:
#  print(l,end="")


featname_re = re.compile('feature(\d+)_name=\w+|feature(\d+)_value\d+_supertype\d+_name=\w+')
featinst_re = re.compile('feat(\d+)_')

lines = open(sys.argv[1]).readlines()

## issue 1--change backslashes in feature names for hyphens
## issue 2--remove mom-feature names (definitions in other-features,
#           need to remove them from lexical rules and entries too 

in_other_features=0
feats_to_delete = {}
# while in_other_features section, read names to delete below
for i,l in enumerate(lines):
  lines[i] = l.replace('\\','-')
  if l.find('section=other-features') != -1:
    in_other_features=1
  elif in_other_features:
    if l.find('section=') != -1:
      in_other_features=0
    else: # read a feature num and then discard
      if featname_re.search(l):
        n = featname_re.search(l).group(1) 
        if not n in feats_to_delete:
          feats_to_delete[n] = True
  else: # anywhere else you match a featinst, delete the line
    m = featinst_re.search(l)
    if m and m.group(1) in feats_to_delete: pass 
    else: print(l, end="")
