#!/usr/bin/env python3

import sys
import re
LINE_RE = re.compile('line=\d+ tag=(\S+):(.*)$')

def create_tags2examples(lines):
  maincounter = 0 
  linecounter = 0
  tags2examples = {}
  for line in lines:
    maincounter+=1
    m = LINE_RE.match(line)
    if m: 
      tags = m.group(1).split("+")
      linecounter+=1
      for t in tags:
        if not t in tags2examples.keys():
          tags2examples[t] = [ [ m.group(1), m.group(2) ] ]
        else:
          tags2examples[t].append([ m.group(1), m.group(2) ])
  return tags2examples



if __name__ == "__main__":
  lines = []
  for arg in sys.argv[1:]:
    lines.extend(open(arg).readlines()) 

  t2e = create_tags2examples(sys.stdin.readlines())

#   print("read "+str(maincounter)+" lines, found "+str(linecounter)+" with line=TAG")
#   for t in sorted(tags2examples, key=lambda x: len(tags2examples[x]), reverse=True):
#     if len(tags2examples[t]) > 3:
#       print(t,str(len(tags2examples[t])), tags2examples[t][0:4],"\n")
#     else:
#       print(t,str(len(tags2examples[t])), tags2examples[t], "\n")
