import re, os, sys, codecs
# TODO CHANGE THIS TO YOUR MOM PATH TO RUN
sys.path.append("/home2/slp24/mom_2.0")
from choices import Feature
import parse_case_features

# author Stephanie Peterson slp24@uw.edu

lexicon_pos_list = {"determiner", "det", "d", "adposition", "adp", "adverb", "adv", "aux", "noun"}

# the lexicon section
class LexiconChoices:
    def __init__(self, lexicon_case_features):
        self.lexicon_section = LexiconSection();
        self.build_lexicon(lexicon_case_features);

    def build_lexicon(self, lexicon_case_features):
        i = 1
        for entry in lexicon_case_features:
            features = [Feature(entry.feature_value, entry.class_pos)]
            self.lexicon_section.add_lexical_entry(entry.class_pos, i, entry.word, features);
            i = i+1

    def write_lexicon(self, file):
        self.lexicon_section.print_to(file)

class LexiconSection():

    def __init__(self):
        self.lexentries = [];

    def print_to(self, file):
        line = "section=lexicon\n".encode('utf8')
        file.write(line.decode('utf-8'));
        for entry in self.lexentries:
            entry.print_to(file);
        file.write("\n");

    def add_lexical_entry(self, pos, index, word, features):
        self.lexentries.append(LexiconEntry(pos, index, word, features));

class LexiconEntry():
    def __init__(self, pos, index, word, features):
        self.pos = pos
        self.index = index
        self.word = word
        self.features = features

    def print_to(self, file):
        if self.pos in lexicon_pos_list:
            file.write(self.pos+str(self.index)+"_orth="+self.word+"\n");
            for feature in self.features:
                file.write(("    "+self.pos+str(self.index)+"_feat"+str(self.index)+"_name="+feature.name+"\n").encode('utf8').decode('utf-8'));
                file.write("    "+self.pos+str(self.index)+"_feat"+str(self.index)+"_value="+feature.value+"\n");

def main(dir, in_file):
        #out_file = open(dir+'choices_output_lexicon', 'w+')
        out_file = codecs.open(dir,'w+', encoding='utf8')
        lexicon_case_features = parse_case_features.CaseParser().parse_lexicon_case_features(in_file)
        choices = LexiconChoices(lexicon_case_features)
        choices.write_lexicon(out_file)
        out_file.close()
