#!/bin/sh

if [ ! $1 ]; then
  echo "provide at least one iso639-3 code as an argument"
  exit
fi

ODINPATH=/projects/igt_annot/fxia/lang_id/stage2_fei/9_2/

for PARAM; do
  echo -n "Putting "
  grep -r "^stage3_lang_chosen:.*($PARAM)" $ODINPATH/g*/*.check | wc -l
  echo -n " IGTs for [$PARAM] in ./$PARAM.txt ..."
  # the following sed script finds blocks (keeping only select lines),
  # then discards those not matching the specified language
  # then massages the output a bit
  sed -e '/./ { /^\(doc_id=\|stage3_lang_chosen:\|line=\)/H; $!d }'\
      -e "x;/\\nstage3_lang_chosen:.* ($PARAM)\\n/!d"\
      -e 's/\nstage3_lang_chosen/\nlanguage/'\
      "$ODINPATH"/g*/*.check | iconv -f iso-8859-1 -t utf-8 > "$PARAM.txt"
  
  echo "done." 
done
