
#!/opt/python-3.4/bin/python3.4
# -*- coding: utf-8 -*-
'''
@from giza.py, author David Wax - waxd@u.washington.edu
@modified by Olga Zamaraeva - olzama@uw.washington.edu
'''
import sys, os, re

class alignables_group():
    '''
    @TODO-COMMENT:
    @TODO-UPDATE: add an interator for this
    '''
    def __init__(self, string=None):
        self.tokens = [];
        if string:
            string = string.strip();
            tokens = re.split("\s+", string);
            for token in tokens:
                #print "adding token from giza.py:", token
                #print "alignable token:", alignable(token)
                self.tokens.append(alignable(token)); 
        self.id = None;

    def __str__(self):
        string = "";
        for token in self.tokens:
            string += str(token)+" ";
        return string;

    #TODO:revise based on grouping features
    def __len__(self):
        return len(self.tokens);

    def token_string(self, group_features=False):
        string = "";
        for i in range(len(self.tokens)):
            if group_features and i+1 < len(self.tokens) and self.tokens[i].is_aligned(self.tokens[i+1]):
                string += str(self.tokens[i])+".";
            else:
                string += str(self.tokens[i])+" ";
        return string;

    def get_id(self):
        return self.id;

    def get_tokens(self):
        #print "get_tokens() called"
        #print str(self)
        #print "tokens: ", [str(i) for i in self.tokens]
        return self.tokens;

def split_path_name(file):
    tokens = re.split("/", file);
    name = tokens.pop();
    path = "/".join(tokens)+"/";
    return (name, path);

class alignable():
    def __init__(self, string=None):
        if string:
            if re.search("\s+",string):
                raise Exception("White space found in alignable object\n");
        self.value = string;
        self.align_list = [];
        self.id = None;

    def __str__(self):
        return self.value;

    ''' given start and end index of a word in a string (from xigt), find this token in igt_line tokens array'''
    def findIndexInLine(self, line, start, end):
        if start == 0:
          return 0
        index = 1
        while index < len(line.tokens):
            cur_token = line.tokens[index]
            print ("current token:",str(cur_token))
            next_start = len(cur_token)+1 #consume space
            if next_start == start:
                print ("found index:",index)
                return index
            index = index + 1
        

    def get_id(self):
        return self.id;

    def is_aligned(self, other_alignable):
        return sorted(self.align_list) == sorted(other_alignable.align_list)

    def add_alignment(self, aligned_to, p=False):
        if p:
            print (self.value+"->"+str(aligned_to));
        self.align_list.append(aligned_to.get_id());

    def is_subset(self, something, boost):
        raise TypeError(" tried to subset "+self.value+" and "+something.value);

    def get_alignments(self):
        return self.align_list;