#!/usr/bin/perl

## script to read plain text trees on a single line and return
## the set of rules used in the tree

while(<>){
$depth=0;
@working_rules = ();

  @toks = split /\s+/, $_;
  foreach $t (@toks) {
    if($t=~m/^\(/){
      # found a label
      # this label is the next daughter of current rule, and also
      # the mother of its own rule
      # unless depth == 0, in that case this is the first rule
      # so we just start it
      $lab = substr $t, 1;
      if ($depth == 0) {
        $working_rules[$depth] = "$lab ->";
        $depth++; 
      } else {
        $working_rules[$depth - 1] .= " $lab ";
        $working_rules[$depth] = "$lab ->";
        $depth++;
      }
    } elsif ($t=~m/\)$/) {
      # found a closer
      # see how many are closing
      while(")" eq substr $t, -1, 1){
        $i = index($t, ")");
        $itm = substr $t, 0, $i;
        $t = substr $t, $i;
	    $working_rules[$depth-1] .= " $itm";
 
		print "$working_rules[$depth-1]\n";
		$depth--;
        $t = substr $t, 0, $#t;
      }
    }
  }
  print "\n";
}
