#!/usr/bin/env python3

## script to read a plain text tree on a single line and return
## the list of production rules used in the tree
import sys 

def getrules(tree):
    working_rules = []
    toks = tree.strip('\n').split(' ')     
    to_return = []
    for t in toks:
        if '(' in t:
            lab = t[1:]
            if len(working_rules) == 0:
                working_rules.append(lab+" ->")
            else:
                working_rules[-1] += " "+lab
                working_rules.append(lab+" ->")
        elif ')' in t:
            while ')' in t:
                i = t.find(')')
                itm = t[:i]
                t = t[i:]
                working_rules[-1] += " "+itm
                to_return.append(working_rules.pop())
                t = t[:-1]

    return to_return
if __name__ == '__main__':
    for t in sys.stdin.readlines():
        for r in getrules(t):
            print(r)

