#!/usr/bin/env python3

import igtall
# import copy
import sys
import re
import subprocess
# from rules_from_tree import getrules
# from tverb import tverb

def get_nps(iaf, outdir, err=None):
    pat = '\`NP'
    tverbs = {}
    tverbs_trans = {}
    count = 0
    all = 0
    npsfile = open(outdir+'/nps.grams', 'w')
    for igt in iaf.igts:
        ## for each igt, we have four trees, the english (transt), the
        ## projected tree (projt), and that pair again with grammatical
        ## functions annotated

        ## and we can get alignment info by quereying the alingment dicts

        t = igt.get('transt')
        # res = {}

        # this is annoying,
        # part1, put the tree in a file
        cmd = 'echo "%(tree)s" > /tmp/tree' % { "tree" : t }
        p = subprocess.Popen(cmd, shell=True)
        p.communicate()


        # convert the file to a 'corpus' file
        cmd = 'tgrep2 -p /tmp/tree /tmp/tmc'
        p = subprocess.Popen(cmd, shell=True)
        p.communicate()


        # finally, search for our pattern
        cmd = 'tgrep2 -t "%(pat)s" -c /tmp/tmc' % { "pat": pat }
        p = subprocess.Popen(cmd, stdout=subprocess.PIPE, shell=True)
        out = p.communicate()[0].decode('utf-8')

        all +=1
        if out.strip('\n') != '':
            count+=1
            np = out.strip(' \n')
            npsfile.write(np+":")
            # try to get the relevant matter from the gloss line
            npwords = np.split()
            transwords = igt.get('trans').split()
            glinds = []
            for w in npwords:
                if not w in transwords:
                    # sanity check: w should be in 'trans' field of igt
                    print("oh no!")
                else:
                    try:
                        glinds.append(igt.tg_dict[str(transwords.index(w)+1)])
                    except KeyError as e:
                        print("error finding item in tg_dict: "+str(igt.tg_dict))
                        print(str(e))
            # if we get here, we should have a series of gloss
            # indices which corresopnd to the words in the translated
            # np # get the grams, then
            grams = []
            for i in glinds:
            # check for subtokens
                if i.find('.') == -1:
                    grams.append(igt.get('gloss').split()[int(i)-1])
                else:
                    [wind,mind] = i.split('.')
                    morphs = igt.get('gloss').split()[int(wind)-1].split('-')
                    grams.append(morphs[int(mind)-1])
            npsfile.write(str(grams)+"\n")


    print("found "+str(count)+\
          " nps based on "+str(all)+\
          " trees read\n")

    #for v in tverbs:
    #    tverbsfile.write("\""+tverbs_trans[v]+"\",\""+v+\
    #                     "\",\""+str(tverbs[v])+"\"\n")


if __name__ == '__main__':
    outdir = sys.argv[1]
    filenm = sys.argv[2]
    iaf = igtall.IgtAllFile(filenm)

    # open an error/log file
    err = open(outdir+'/nps.log', 'w')
    get_nps(iaf, outdir, err=err)

