#!/usr/bin/env python3

import igtall
# import copy
import sys
import re
import subprocess
# from rules_from_tree import getrules
# from tverb import tverb

def get_verbs(iaf, outdir, param, err=None):
    pat = ''
    treefile = open(outdir+"/"+param+"trees", 'w')
    if param == '2':
        pat = 'S < NP << ( VP [ < NP | < PP ] [ << \`/^VB/ ] )'
    elif param == '1': 
        pat = 'S < NP << ( VP [ !< NP !< PP !<ADJP ] [ << \`/^VB/ ] )'
    tverbs = {}
    tverbs_trans = {}
    count = 0
    all = 0
    for igt in iaf.igts: 
        ## for each igt, we have four trees, the english (transt), the 
        ## projected tree (projt), and that pair again with grammatical 
        ## functions annotated

        ## and we can get alignment info by quereying the alingment dicts

        t = igt.get('transt')
        # res = {}

        # this is annoying,
        # part1, put the tree in a file
        cmd = 'echo "%(tree)s" > /tmp/tree' % { "tree" : t }
        p = subprocess.Popen(cmd, shell=True)
        p.communicate()
        

        # convert the file to a 'corpus' file
        cmd = 'tgrep2 -p /tmp/tree /tmp/tmc'
        p = subprocess.Popen(cmd, shell=True)
        p.communicate()


        # finally, search for our pattern
        cmd = 'tgrep2 -t "%(pat)s" -c /tmp/tmc' % { "pat": pat }  
        p = subprocess.Popen(cmd, stdout=subprocess.PIPE, shell=True)
        out = p.communicate()[0].decode('utf-8')

        all +=1
        if out.strip('\n') != '':
            count+=1
            treefile.write("MATCH: "+t+"\n")
            v = out.strip(' \n')
            # try to get translation
            orig = igt.get_text_from_trans(v)
            if orig == None:
                tverbs_trans[v] = '***NONE***'
                if err != None:
                    err.write("get_text_from_trans("+v+") failed, this is the igt:\n")
                    igt.print_self(errf=err)
                    err.write("\n")
                else:
                    print("get_text_from_trans("+v+") failed, this is the igt:\n", file=sys.stderr)
                    igt.print_self(err=True)
                    print("",file=sys.stderr)
            elif orig.startswith('-1'):
                tverbs_trans[v] = '***NONE***'
                err.write("get_text_from_trans("+v+") failed, this is the igt:\n")
                igt.print_self(errf=err)
                err.write(orig+"\n")
            elif orig.startswith('-2'):
                tverbs_trans[v] = '***NONE***'
                err.write("get_text_from_trans("+v+") failed, this is the igt:\n")
                igt.print_self(errf=err)
                err.write(orig+"\n")
            else:
                tverbs_trans[v] = orig

            if v in tverbs.keys(): 
                tverbs[v] += 1
            else:
                tverbs[v] = 1
 
        else:
            treefile.write("NOMATCH: "+t+"\n")

    print("found "+str(count)+\
          " trees with verbs with val:"+param+" based on "+str(all)+\
          " trees read\n")

    tverbsfile = open(outdir+'/'+param+'verbs', 'w')
    tverbsfile.write("\"verbform\",\"engtrans\",\"count\"\n")
    for v in tverbs:
        tverbsfile.write("\""+tverbs_trans[v]+"\",\""+v+\
                         "\",\""+str(tverbs[v])+"\"\n")
        

if __name__ == '__main__':
    outdir = sys.argv[1]
    filenm = sys.argv[2]
    param = sys.argv[3]
    iaf = igtall.IgtAllFile(filenm)

    # open an error/log file
    err = open(outdir+'/err', 'w')
    get_verbs(iaf, outdir, param, err=err)

