#!/usr/bin/env python3
## take a text file with s,v,o counts and
## and compute a matrix of sum of square diffs
## for each lang pair


# input file has a header with col names
# and the first col is row names ('langs')

import sys
import math

# read infile from stdin

inlines = sys.stdin.readlines()
# need to normalize to a probablilty mass function
normed = [ inlines[0].split(",") ]
for row in inlines[1:]:
  cells=row.split(',')
  # lname goes in first cell of out for this row
  normcells = [ cells[0].strip("\"'") ]
  rowsum = sum([float(c) for c in cells[1:] ])
  normcells.extend([ float(c)/rowsum for c in cells[1:] ])
  normed.append(normcells)

# print(normed, file=sys.stderr)



# outtable will be a csv format again
# for now, use a list of lists
outtable = [ [''] ]

# langnames are in first column
outtable[0].extend([t[0].strip("\"'") for t in 
                [ r.split(',') for r in inlines[1:] ]])

 

# loop on the inrows
# use alldiffs and n to calculate average distance
# for the whole group
alldiffs = 0.0
n = 0
for i in range(1,len(normed)):
  cells=normed[i]
  # print("cells:", cells,file=sys.stderr)

  # lname goes in first cell of out for this row
  outrow = [ cells[0].strip("\"'") ]
  # inner loop on inrows to compare to ever other lang
  for j in range(1,len(normed)):
    if i!=j: n+=1
    diff_sum = 0.0
    for x in range(1,len(cells)):
      diff_sq = (float(cells[x]) - float(normed[j][x]))**2
      diff_sum+=diff_sq

    outrow.append(diff_sum)
    alldiffs+=diff_sum

  outtable.append(outrow)

print('"', '","'.join(outtable[0]),'"',sep="")
for i in outtable[1:]:
  for j in range(0,len(i)):
    if j == 0:
      print('"',i[j],'"',sep="", end=",")
    elif j==len(i)-1:
      print(i[j])
    else:
      print(i[j],end=",")

avgdist = alldiffs/float(n/4)
print("avg distance for all pairs: ",avgdist)
