import ChoicesReader
import map_gloss

class Evaluation:

    def test():
        print(test)

class Language:

    objects = {}

    def _init__(self, iso, gold_path, infer_path):
        self._iso = iso
        self._gold_path = gold_path
        self._infer_path = infer_path
        self._confusion_matrix = {}
        self._precision = 0.0
        self._recall = 0.0
        self._fscore = 0.0
        Language.objects[iso] = self
        Choices(iso, 'gold', gold_path)
        Choices(iso, 'infer', infer_path)

    def set_confusion_matrix(self):
        self._confusion_matrix = {'FNeg': {}, 'FPos': {}, 'TPos': {}}
        # Tense
        infer_match = {}
        for t1 in Choices.objects[(self._iso, 'gold')]._tenses:
            match = False
            for t2 in Choices.objects[(self._iso, 'infer')]._tenses:
                for value in Choices.objects[(self._iso, 'infer')]._tenses[t2]:
                    if t1.lower() == value.lower():
                        match == True
                        infer_match[t2] = True
            if match == True:
                self._confusion_matrix['TPos'][t1] = True
            else:
                self._confusion_matrix['FNeg'][t1] = True
        for t2 in Choices.objects[(self._iso, 'infer')]._tenses:
            if t2 not in infer_match:
                self._confusion_matrix['FPos'][t2] = True
        # Aspect
        infer_match = {}
        for a1 in Choices.objects[(self._iso, 'gold')]._aspects:
            match = False
            for a2 in Choices.objects[(self._iso, 'infer')]._aspects:
                for value in Choices.objects[(self._iso, 'infer')]._aspects[a2]:
                    if a1.lower() == value.lower():
                        match == True
                        infer_match[a2] = True
            if match == True:
                self._confusion_matrix['TPos'][a1] = True
            else:
                self._confusion_matrix['FNeg'][a1] = True
        for a2 in Choices.objects[(self._iso, 'infer')]._aspects:
            if a2 not in infer_match:
                self._confusion_matrix['FPos'][a2] = True
        # Mood
        infer_match = {}
        for m1 in Choices.objects[(self._iso, 'gold')]._moods:
            match = False
            for m2 in Choices.objects[(self._iso, 'infer')]._moods:
                for value in Choices.objects[(self._iso, 'infer')]._moods[m2]:
                    if m1.lower() == value.lower():
                        match == True
                        infer_match[m2] = True
            if match == True:
                self._confusion_matrix['TPos'][m1] = True
            else:
                self._confusion_matrix['FNeg'][m1] = True
        for m2 in Choices.objects[(self._iso, 'infer')]._moods:
            if m2 not in infer_match:
                self._confusion_matrix['FPos'][m2] = True

class Choices:

    objects = {}

    def __init__(self, iso, value, path):
        self._iso = iso
        self._value = value
        self._path = path
        self._choices_file = ''
        self._tenses = {}
        self._aspects = {}
        self._moods = {}
        Choices.obejcts[(iso, value)] = self
        self.load_file()
        self.set_tenses()
        self.set_aspects()
        self.set_moods()

    def load_file(self):
        self._choices_file = ChoicesReader.ChoicesFile(self._path)

    def set_tenses():
        for tense in self._choices_file.tenses():
            try:
                self._tenses[tense] = map_gloss.Gloss.objects[(self._iso,
                                                    tense)].get_references()
            except:
                self._tenses[tense] = {tense: True}
        return True

    def set_aspects():
        for aspect in self._choices_file.aspects():
            try:
                self._aspects[aspect] = map_gloss.Gloss.objects[(self._iso,
                                                    aspect)].get_references()
            except:
                self._aspects[aspect] = {aspect: True}
        return True

    def set_moods():
        for mood in self._choices_file.moods():
            try:
                self._moods[mood] = map_gloss.Gloss.objects[(self._iso,
                                                    mood)].get_references()
            except:
                self._moods[mood] = {mood: True}
        return True



class Baseline:

    objects = {}
        
