# Kristen Howell
# This is a one-off script for adding verb pos tags to Nuuchahnulth [nuk] IGT that have only one word and the root of the English translation is a verb

from xigt.codecs import xigtxml
from xigt import XigtCorpus
from xigt import Tier, Item

nuk_file = 'C:/Users/Kristen/Documents/code/agg/data/nuk/xigt/nuk_enriched.xml'
new_file = 'C:/Users/Kristen/Documents/code/agg/data/nuk/xigt/nuk_enriched_verb_tags.xml'
nuk_corpus = xigtxml.load(open(nuk_file, encoding='utf-8'))
new_corpus = XigtCorpus(id=nuk_corpus.id, metadata=nuk_corpus.metadata)


for igt in nuk_corpus:
    verb_root = False
    words = igt.get('p').get('p1').value().strip('.').split()
    if len(words) == 1:
        if igt.get('tw-ds') and igt.get('tw-pos'):
            for ds in igt.get('tw-ds'):
                if ds.value() == 'root':
                    root = ds.attributes['dep']
                    for pos in igt.get('tw-pos'):
                        if pos.alignment == root:
                            if pos.value() == 'VERB':
                                verb_root = True
    if verb_root:
        pos_tier = Tier(id='pos',
                     type='syntax',
                       alignment='w')
        verb_tier = Item(id='pos1',
                         alignment='w1',
                         text='VERB')
        pos_tier.append(verb_tier)
        igt.append(pos_tier)
    new_corpus.append(igt)


xigtxml.dump(open(new_file, 'w', encoding='utf-8'), new_corpus)