# Kristen Howell
# this plots the results from my dissertation

import numpy as np
import matplotlib.pyplot as plt


# N = 5
# menMeans = (20, 35, 30, 35, 27)
# womenMeans = (25, 32, 34, 20, 25)
# menStd = (2, 3, 4, 1, 2)
# womenStd = (3, 5, 2, 3, 3)
# ind = np.arange(N)    # the x locations for the groups
# width = 0.35       # the width of the bars: can also be len(x) sequence
#
# p1 = plt.bar(ind, menMeans, width, yerr=menStd)
# p2 = plt.bar(ind, womenMeans, width,
#              bottom=menMeans, yerr=womenStd)
#
# plt.ylabel('Scores')
# plt.title('Scores by group and gender')
# plt.xticks(ind, ('G1', 'G2', 'G3', 'G4', 'G5'))
# plt.yticks(np.arange(0, 81, 10))
# plt.legend((p1[0], p2[0]), ('Men', 'Women'))
#
# plt.show()

arp_lex = [3.64, 3.52, 3.64, 3.18]
arp_cov = [3.04, 3.06, .5, .26]
arp_cor = [.17, .2, 0, .03]
arp_feat = [.09, .06, 0, 0]

hix_lex = [38.09, 36.01, 35.88, 35.92]
hix_cov = [34.18, 31.28, 2.8, 1.25]
hix_cor = [2.26, 2.26, 1.57, .52]
hix_feat = [0, 0, 0, 0]

#############333
#check from here down
erk_lex = [12.8, 13.55, 14.29, 13.17]
erk_cov = [6.77, 9.81, .27, .27]
erk_cor = [.33, .27, 0, 0]
erk_feat = [.15, 0, 0,0]

ttv_lex = [13.56, 19.40, 20.34, 19.40]
ttv_cov = [10.34, 16.18, .09, .19] # cov is slightly lower than cor because of the way the splits shook out- didn't tb every split. these are the actual numbers for the last two: .06, .17]
ttv_cor = [.28, .65, .09, .19]
ttv_feat = [.19, 0, 0, 0]

wbl_lex = [39.68, 29.72, 31.48, 31.04]
wbl_cov = [30.31, 24.89, 10.25, 3.22]
wbl_cor = [14.20, 12.75, 2.61, .58]
wbl_feat = [5.8, .58, 0, 0]

true_lex = [arp_lex, hix_lex, erk_lex, ttv_lex, wbl_lex]
true_cov = [arp_cov, hix_cov, erk_cov, ttv_cov, wbl_cov]
true_cor = [arp_cor, hix_cor, erk_cor, ttv_cor, wbl_cor]
true_feat = [arp_feat, hix_feat, erk_feat, ttv_feat, wbl_feat]

feat = true_feat
cor = [[true_cor[j][i]-feat[j][i] for i in range(4)] for j in range(5)]
cov = [[true_cov[j][i]-cor[j][i] for i in range(4)] for j in range(5)]
lex = [[true_lex[j][i]-cov[j][i] for i in range(4)] for j in range(5)]


N = 5
ind = np.arange(N)
width = 0.15

rand = np.arange(len([x[0] for x in lex]))
typ = [x + width for x in rand]
broad = [x + width for x in typ]
inf = [x + width for x in broad]

linecolor = 'black'

#blue used to be #396AB1
# Make the plot
p1 = plt.bar(inf, [x[0] for x in lex], bottom=[x[0] for x in cov], width=width, color='#4275c2', hatch='0', edgecolor=linecolor, label='RAND')
p2 = plt.bar(broad, [x[1] for x in lex], bottom=[x[1] for x in cov], width=width, color='#DA7C30', hatch='0', edgecolor=linecolor, label='TYP')
p3 = plt.bar(typ, [x[2] for x in lex], bottom=[x[2] for x in cov], width=width, color='#3E9651', hatch='0', edgecolor=linecolor, label='BROAD')
p4 = plt.bar(rand, [x[3] for x in lex], bottom=[x[3] for x in cov], width=width, color='#CC2529', hatch='0', edgecolor=linecolor, label='BASIL')

p5 = plt.bar(inf, [x[0] for x in cov], bottom=[x[0] for x in cor], width=width, color='#4275c2', hatch='///', edgecolor=linecolor, label='RAND')
p6 = plt.bar(broad, [x[1] for x in cov], bottom=[x[1] for x in cor], width=width, color='#DA7C30', hatch='///', edgecolor=linecolor, label='TYP')
plt.bar(typ, [x[2] for x in cov], bottom=[x[2] for x in cor], width=width, color='#3E9651', hatch='///', edgecolor=linecolor, label='BROAD')
plt.bar(rand, [x[3] for x in cov], bottom=[x[3] for x in cor], width=width, color='#CC2529', hatch='///', edgecolor=linecolor, label='BASIL')

p9 = plt.bar(inf, [x[0] for x in cor], bottom=[x[0] for x in feat], width=width, color='#4275c2', hatch='xxx', edgecolor=linecolor, label='RAND')
plt.bar(broad, [x[1] for x in cor], bottom=[x[1] for x in feat], width=width, color='#DA7C30', hatch='xxx', edgecolor=linecolor, label='TYP')
plt.bar(typ, [x[2] for x in cor], bottom=[x[2] for x in feat], width=width, color='#3E9651', hatch='xxx', edgecolor=linecolor, label='BROAD')
plt.bar(rand, [x[3] for x in cor], bottom=[x[3] for x in feat], width=width, color='#CC2529', hatch='xxx', edgecolor=linecolor, label='BASIL')

p13 = plt.bar(inf, [x[0] for x in feat], width=width,  color='#4275c2', hatch='------', edgecolor=linecolor, label='RAND')
plt.bar(broad, [x[1] for x in feat], width=width, color='#DA7C30', hatch='------', edgecolor=linecolor, label='TYP')
plt.bar(typ, [x[2] for x in feat], width=width, color='#3E9651', hatch='------', edgecolor=linecolor, label='BROAD')
plt.bar(rand, [x[3] for x in feat], width=width, color='#CC2529', hatch='------', edgecolor=linecolor, label='BASIL')


l1 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='0', edgecolor=linecolor)
l2 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='///', edgecolor=linecolor)
l3 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='xxx', edgecolor=linecolor)
l4 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='------', edgecolor=linecolor)

plt.ylabel('Percent Correct')
plt.title('Lexical Coverage, Parse Coverage, Correct Pred-arg Structure, and Correct Features by Language')
#plt.minorticks_on()
plt.xticks([x + .2 for x in ind], ('Arapaho', 'Hixkaryana', 'South Efate', 'Titan', 'Wakhi'),rotation=45)
#plt.xticks([.25, .5, .75, 1, 1.5, 1.75, 2, 2.25, 2.75, 3, 3.25, 3.5, 4, 4.25, 4.5, 4.75, 5.25, 5.5, 5.75, 6], ('RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL'), rotation=45)

legend1 = plt.legend((p4, p3, p2, p1), ('RAND', 'TYP', 'BROAD', 'BASIL'),loc=1)
legend2 = plt.legend([l1, l2, l3, l4], ('Lexical Coverage', 'Parse Coverage', 'Correct Pred-arg Structure', 'Correct Pred-arg Structure and Features'),loc=2)
plt.gca().add_artist(legend1)
#plt.gca().add_artist(legend2)
plt.yticks(np.arange(0, 52, 10))
plt.show()


# Make the plot
p9 = plt.bar(inf, [x[0] for x in cor], bottom=[x[0] for x in feat], width=width, color='#4275c2', hatch='xxx', edgecolor=linecolor, label='RAND')
plt.bar(broad, [x[1] for x in cor], bottom=[x[1] for x in feat], width=width, color='#DA7C30', hatch='xxx', edgecolor=linecolor, label='TYP')
plt.bar(typ, [x[2] for x in cor], bottom=[x[2] for x in feat], width=width, color='#3E9651', hatch='xxx', edgecolor=linecolor, label='BROAD')
plt.bar(rand, [x[3] for x in cor], bottom=[x[3] for x in feat], width=width, color='#CC2529', hatch='xxx', edgecolor=linecolor, label='BASIL')

p13 = plt.bar(inf, [x[0] for x in feat], width=width,  color='#4275c2', hatch='------', edgecolor=linecolor, label='RAND')
plt.bar(broad, [x[1] for x in feat], width=width, color='#DA7C30', hatch='------', edgecolor=linecolor, label='TYP')
plt.bar(typ, [x[2] for x in feat], width=width, color='#3E9651', hatch='------', edgecolor=linecolor, label='BROAD')
plt.bar(rand, [x[3] for x in feat], width=width, color='#CC2529', hatch='------', edgecolor=linecolor, label='BASIL')


l1 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='0', edgecolor=linecolor)
l2 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='///', edgecolor=linecolor)
l3 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='xxx', edgecolor=linecolor)
l4 = plt.bar(inf, [0 for x in cor], width=width, color='white', hatch='------', edgecolor=linecolor)

plt.ylabel('Percent Correct')
plt.title('Correct Pred-arg Structure and Correct Features by Language')
#plt.minorticks_on()
plt.xticks([x + .2 for x in ind], ('Arapaho', 'Hixkaryana', 'South Efate', 'Titan', 'Wakhi'),rotation=45)
#plt.xticks([.25, .5, .75, 1, 1.5, 1.75, 2, 2.25, 2.75, 3, 3.25, 3.5, 4, 4.25, 4.5, 4.75, 5.25, 5.5, 5.75, 6], ('RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL', 'RAND', 'TYP', 'BROAD', 'BASIL'), rotation=45)

legend1 = plt.legend((l3, l4, p4, p3, p2, p1), ('Correct Pred-arg Structure', 'Correct Pred-arg Structure and Features', 'RAND', 'TYP', 'BROAD', 'BASIL'), loc=2)
#legend2 = plt.legend([l1, l2, l3, l4], ('Lexical Coverage', 'Parse Coverage', 'Correct Pred-arg Structure', 'Correct Pred-arg Structure and Features'),loc=1)
plt.gca().add_artist(legend1)
#plt.gca().add_artist(legend2)
plt.yticks(np.arange(0, 15, 2))
plt.show()


N = 9
ind = np.arange(N)
width = 0.35
linecolor='black'

true_lex = [53.19,22.29,17.49,7.88,12.61,5.86,23.09,9.41,28.79]
true_cov = [41.96,12.24,10.29,6.08,8.02,5.24,10.14,2.08,24.05]
true_cor = [10.19,3.58,1.79,0,1.15,1.05,1.87,.98,4.35]
true_feat = [5.73,1.94,.89,0,1.15,.42,1.09,0.12,0]

feat = true_feat
cor = [true_cor[x]-feat[x] for x in range(0,N)]
cov = [true_cov[x]-cor[x] for x in range(0,N)]
lex = [true_lex[x]-cov[x] for x in range(0,N)]

d1 = plt.bar(ind, lex, width, bottom=cov, color='#4275c2', hatch='0', edgecolor=linecolor)
d2 = plt.bar(ind, cov, width, bottom=cor, color='#4275c2', hatch='///', edgecolor=linecolor)
d3 = plt.bar(ind, cor, width, bottom=feat, color='#4275c2', hatch='xxx', edgecolor=linecolor)
d4 = plt.bar(ind, feat, width, color='#4275c2', hatch='------', edgecolor=linecolor,)

plt.ylabel('Percent Correct')
plt.title('Lexical Coverage, Parse Coverage, Correct Pred-arg Structure, and Correct Features by Language')
#plt.minorticks_on()
plt.xticks(ind, ('Abui','Chintang','Haiki','Lezgi','Matsigenka','Meithei','Nuuchahnulth','Wambaya','Tsova-Tush'),rotation=45)

#legend1 = plt.legend((p4[0], p3[0], p2[0], p1[0]), ('RAND', 'TYP', 'BROAD', 'BASIL'), loc=1)
plt.legend([d1, d2, d3, d4], ('Lexical Coverage', 'Parse Coverage', 'Correct Pred-arg Structure', 'Correct Pred-arg Structure and Features'))
#plt.gca().add_artist(legend1)
#plt.gca().add_artist(legend2)
plt.yticks(np.arange(0, 60, 10))
plt.show()