from inference_scripts import infer_adnominal_possession


# Caveat: Currently only looks at IGT with exactly one instance of possession, as marked by the tw-ds tier.
# Caveat: Only looks at possessor pronouns.
# Caveat: Only looks at possessors that are marked with genitive case in which the genitive case marker is its own morpheme that's glossed separately from the possessor pronoun morpheme using the gloss 'gen'.
# Caveat: Only looks at possessor pronouns that are marked by a single additional morpheme (the genitive case marker).

def reenrich_possession(xigtfile):

    for igt in xigtfile:

        if igt.get('t') and igt.get('g') and igt.get('tw-g-aln') and igt.get('gw') and igt.get('tw-ds'):

            if infer_adnominal_possession.has_poss(igt) == 1: # if the IGT has 1 instance of possession, as indicated by the tw_ds tier

                tTier = igt.get('t')
                gTier = igt.get('g')
                twTier = igt.get('tw-g-aln')
                gwTier = igt.get('gw')

                for gen_g in gTier:
                    gen_gloss = gen_g.value()
                    if gen_gloss == 'gen':

                        for psr_g in gTier:
                            other_morpheme_glosses_in_the_word = []
                            if psr_g.attributes['segmentation'] == gen_g.attributes['segmentation'] and psr_g != gen_g:
                                other_morpheme_glosses_in_the_word.append(psr_g)
                                if len(other_morpheme_glosses_in_the_word) == 1: #if the word only contains the genitive gloss and one other morpheme
                                    psr = other_morpheme_glosses_in_the_word[0].id
                                    
                                    # Check whether there's an alignment for the psr gloss
                                    gloss_is_aligned = False

                                    for alignment in twTier:
                                        if alignment.attributes['target'] == psr:
                                            print('An alignment has been found.')
                                            print(psr)
                                            gloss_is_aligned = True
                                    
                                    if gloss_is_aligned == False:
                                        print(psr)
                                        for t in tTier:
                                            print(t)


        

    return xigtfile