# Kristen Howell
# a script for creating train/test splits for 10 fold cross validation

from xigt.codecs import xigtxml
from xigt import XigtCorpus
import random
import sys

iso = 'yaq'#sys.argv[1]
odin_orig = False
print(iso)
#xigt_file = 'C:/Users/Kristen/Documents/code/agg/data/' + iso + '/xigt/' + iso + '_no_spaces.xml'
xigt_file = 'C:/Users/Kristen/Documents/code/agg/data/' + iso + '/xigt/' + iso + '_better_glossing.xml'
enriched_file = 'C:/Users/Kristen/Documents/code/agg/data/' + iso + '/xigt/' + iso + '_better_glossing.xml'
#enriched_file = 'C:/Users/Kristen/Documents/code/agg/data/' + iso + '/splits/xigt/clean/' + iso + '_all_enriched.xml'
train_file = 'C:/Users/Kristen/Documents/code/agg/data/' + iso + '/xigt/' + iso + '_train'
test_file = 'C:/Users/Kristen/Documents/code/agg/data/' + iso + '/xigt/' + iso + '_test'
if odin_orig:
    xigt_file = enriched_file

enriched_corpus = xigtxml.load(open(enriched_file,encoding='utf-8'))
xigt_corpus = xigtxml.load(open(xigt_file,encoding='utf-8'))

splits = {}
train_xc = XigtCorpus(id=enriched_corpus.id, metadata=enriched_corpus.metadata)
test_xc = XigtCorpus(id=xigt_corpus.id, metadata=xigt_corpus.metadata)
print('corpus loaded')
corpus_list = [x for x in enriched_corpus]
deduped_corpus_list = []
for x in corpus_list:
    dup = False
    hastrans = True
    for y in deduped_corpus_list:
        if x.get('p') and y.get('p') and x.get('t') and y.get('t'):
            if x.get('p')[0].value() == y.get('p')[0].value() and x.get('t')[0].value() == y.get('t')[0].value():
                if len(x.get('gw')) == len(y.get('gw')):
                    if all([True for gwx in x.get('gw') if gwx.value() == y.get('gw').get(gwx.id).value()]):
                        dup = True
        else:
            hastrans = False
    if not dup:
        if hastrans:
            deduped_corpus_list.append(x)

full_corpus_length = len(corpus_list)
deduped_corpus_length = len(deduped_corpus_list)
print('Removed ' + str(full_corpus_length-deduped_corpus_length) + ' duplicates from corpus')
# weed out ungrammaticals
for igt in deduped_corpus_list:
    if '*' in igt.get('p')[0].value():
        deduped_corpus_list.remove(igt)
grammatical_corpus_length = len(deduped_corpus_list)
print('Removed ' + str(full_corpus_length-grammatical_corpus_length) + ' ungrammatical igt from corpus')
random.shuffle(deduped_corpus_list)
test_size = .1 * len(deduped_corpus_list)
print(len(deduped_corpus_list))

if iso == 'arp':
    deduped_corpus_list = deduped_corpus_list[0:400]

i = 1
j = 0
while i < 11:
    train_xc = XigtCorpus(id=enriched_corpus.id, metadata=enriched_corpus.metadata)
    test_xc = XigtCorpus(id=xigt_corpus.id, metadata=xigt_corpus.metadata)
    test_ids = []
    while j//i < test_size and j < len(deduped_corpus_list):
        test_ids.append(deduped_corpus_list[j].id)
        j += 1
    for igt in deduped_corpus_list:
        if igt.id not in test_ids:
            train_xc.append(igt)
    for igt in xigt_corpus:
        if igt.id in test_ids:
            test_xc.append(igt)
    print(len(test_ids))

    splits[str(i)] = {'train': train_xc, 'test': test_xc}
    print('split ' + str(i) + ' complete')
    i += 1

for split in splits:
    xigtxml.dump(open(train_file+split+'.xml', 'w', encoding='utf-8'), splits[split]['train'])
    xigtxml.dump(open(test_file+split+'.xml', 'w', encoding='utf-8'), splits[split]['test'])
    print(split)
print('splits dumped')


#xigtxml.dump(open(train_file, 'w', encoding='utf-8'), train_xc)
#xigtxml.dump(open(test_file, 'w', encoding='utf-8'), test_xc)

