#!/usr/bin/env python3
# -*- coding: utf-8 -*
# Author: Kristen Howell

# helper functions to build hierarchy for tam features and update lex rules
# this script is not finished and not used by BASIL

from XigtifiedToolbox import FeatDict
import re



def consolidate_tam_feats(item, choices, type):
    ## the goal of this method is to build a hierarchy for any tam features that co-occur in the same lex rule, so that both
    ## with be captured in the semantics
    tam_feats = {'self':{'person': set(), 'number': set()},'subj':{'person': set(), 'number': set()}, 'obj':{'person': set(), 'number': set()}}
    feat_keys = []
    new_feats = []
    for feat in item['feat']:
        if feat['name'] == type:
            new_feats.append(feat['value'])
            if item.full_key not in feat.full_key:
                feat_keys.append(item.full_key+'_'+feat.full_key)
            else:
                feat_keys.append(feat.full_key)
    if len(new_feats) > 1:
        supertype = '-'.join(sorted(new_feats))
        if any([True for subtype in choices[type] if subtype['name'] == supertype]):
            choices[feat_keys[0] + '_value'] = supertype
        else:
            last_id = '0'
            for subtype in choices[type]:
                if subtype['name'] in new_feats:
                    subtype['supertype'] = supertype
                last_id = re.sub(type,'',subtype.full_key)
            choices[type + str(int(last_id)+1) + '_name'] = supertype
            choices[type + str(int(last_id)+1) + '_supertype' + str(int(last_id)+1) + '_name'] = type
        for key in feat_keys[1:]:
            del choices[key]


def update_tam_feats(choices, type):
    for pc in choices['verb-pc']:
        for lrt in pc['lrt']:
            consolidate_tam_feats(lrt, choices, type)

    pos_list = ['verb', 'aux']
    for pos in pos_list:
        if pos in choices:
            for word in choices[pos]:
                consolidate_tam_feats(word, choices, type)
    return choices
