#!/usr/bin/python3
# -*- coding: utf-8 -*

import sys
import os
import re
from collections import defaultdict, Counter
from xigt import xigtpath as xp
from xigt import ref
from xigt.codecs import xigtxml

def get_case_grams_from_igt_item(xc):
    global item_count
    global case_grams
    gram_count = 0
    igt_count = 0
    case_grams = {}
    for each in all_case_grams:
        case_grams[each] = 0
        item_count += 1
		
    #for gram in xp.findall(xc, '//tier[@type="glosses"]/item/value()'):
    for g in xp.findall(xc, '//tier[@id="g"]/item/value()'):
        grams = g.split('.')
        for gram in grams:
            if gram in case_grams or gram.lower() in case_grams:
                case_grams[gram.lower()] += 1
                gram_count += 1
        igt_count += 1

def get_case_system():
    # if a case gram appears in less than 2% of examples, discard it
    for gram, count in case_grams.items():
        if float(count) / float(item_count) < 0.02:
            case_grams[gram] = 0

    case = 'none'
    if case_grams['nom'] + case_grams['acc'] > 0 and \
                            case_grams['erg'] + case_grams['abs'] == 0:
        case = 'nom-acc'
    elif case_grams['erg'] + case_grams['abs'] > 0 and \
                            case_grams['nom'] + case_grams['acc'] == 0:
        case = 'erg-abs'
    elif case_grams['nom'] + case_grams['acc'] > 0 and \
                            case_grams['erg'] + case_grams['abs'] > 0:
        case = 'split-erg'


    #sys.stderr.write(os.path.basename(file_name)[:3] + '\t' + 'case-marking: \t {}'.format(case) + '\n')
    print('case-marking: \t {}'.format(case))
    return case

def infer_case(xc):
    #file = open(file_name, encoding="UTF-8")
    #xc = xigtxml.load(file)
    get_case_grams_from_igt_item(xc)
    return get_case_system()
    
all_case_grams = {'nom', 'acc', 'abs', 'erg', 'abl', 'all',
                  'com', 'dat', 'gen', 'ins', 'loc', 'obl'}

gram_punc_re = re.compile(r'\.|-|=|:')
verb_types = {}

# Global variables
item_count = 0
case_grams = Counter()

if __name__ == '__main__':
    file_name = sys.argv[1]
    infer_case(file_name)