#!/usr/bin/env python3
# -*- coding: utf-8 -*
# Author: Kristen Howell
# this script runs infer-arg-opt on a set of languages
# used for Kristen's generals paper

import sys
from xigt.codecs import xigtxml
from inference_scripts import infer_arg_opt
import MatrixChoices

DEV_LANGS = ['cmn', 'eus', 'mcb', 'tur', 'ita']
TEST_LANGS = ['hau', 'isl', 'fin', 'nld', 'jpn', 'rus', 'nob', 'kor', 'ell', 'hun', 'pqm', 'bul', 'cng', 'ind', 'pol', 'xub']
DATA_PATH = 'C:/Users/Kristen/Documents/code/aggregation/data/arg-opt-2018/'
CHOICES_PATH = 'C:/Users/Kristen/Documents/code/aggregation/analyses/arg-opt-2018/gold_choices/'
RESULTS_PATH = 'C:/Users/Kristen/Documents/code/aggregation/analyses/arg-opt-2018/inferred_choices/'

for lang in DEV_LANGS:
    print(lang)
    corpus = open(DATA_PATH+'dev/'+lang+'.xml', encoding='utf-8')
    xc = xigtxml.load(corpus)
    choices = infer_arg_opt.infer_arg_opt(xc)
    infer_arg_opt.write_choices_file(choices,RESULTS_PATH+lang)
    gold_choices = MatrixChoices.ChoiceDict()
    with open(CHOICES_PATH+lang,encoding='utf-8') as f:
        gold_choices_file = f.readlines()
    for choice in choices:
        gold_choices.__setitem__(choice, MatrixChoices.get_choice(choice,gold_choices_file))
    incorrect_items = {k: choices[k] for k in choices if k in gold_choices and choices[k] != gold_choices[k]}
    print(str(len(incorrect_items))+'/'+str(len(gold_choices)))
    print(str(incorrect_items))
