#!/bin/bash

# usage: art-parse GRAMMAR_DIR SKELETON_DIR PROF_DIR

if [ -z "$AGGREGATIONHOME" ]; then
  echo "AGGREGATIONHOME is not set. Attempting to locate." >&2
  curdir=$( cd `dirname "$0"`/.. && pwd)
  if [ -z "$curdir" ]; then
    echo "AGGREGATIONHOME directory could not be found. Exiting." >&2
    exit 1
  fi
  AGGREGATIONHOME="$curdir"
fi

GRAM_DIR="$1"
SKEL_DIR="$2"
PROF_DIR="$3"

mkdir -p "$TSDB_HOME"
ace -g "$GRAM_DIR"/ace/config.tdl -G "$GRAM_DIR"/grammar.dat
mkprof -s "$SKEL_DIR" "$PROF_DIR"
art -a "ace -g \"$GRAM_DIR\"/grammar.dat" "$PROF_DIR"
