#!/bin/bash
#Usage:
# ./infer-case-from-counts.py

> log.tmp
svn up -r39093 >> log.tmp

chmod +x scripts/*

echo "SAO Method on ODIN Data"
for language in ../data/infer-case_2017/data-from-odin/*; 
do ./scripts/infer-case-from-counts-xigt.py $language
iso=$(basename "$language" ".xml")
grep $iso ../data/infer-case_2017/gold_case.txt
echo; done

echo "GRAM Method on ODIN Data"
for language in ../data/infer-case_2017/data-from-odin/*; 
do ./scripts/infer-case-from-grams-xigt.py $language
iso=$(basename "$language" ".xml")
grep $iso ../data/infer-case_2017/gold_case.txt
echo; done

echo "SAO Method on MapGlossed ODIN Data"
for language in ../data/infer-case_2017/mapglossed-data-from-odin/*; 
do ./scripts/infer-case-from-counts-xigt.py $language
iso=$(basename "$language" ".xml")
grep $iso ../data/infer-case_2017/gold_case.txt
echo; done

echo "GRAM Method on MapGlossed ODIN Data"
for language in ../data/infer-case_2017/mapglossed-data-from-odin/*; 
do ./scripts/infer-case-from-grams-xigt.py $language
iso=$(basename "$language" ".xml")
grep $iso ../data/infer-case_2017/gold_case.txt
echo; done

echo "SAO Method on Language Collage"
chmod +x scripts/*
declare -a directories='dev1 dev2 test new'
for dir in $directories; do
for language in ../data/567/$dir/*; do 
iso=$(basename "$language")
svn update -r38389 &>> log.tmp
mkdir sample_out
chmod +x scripts/*
./scripts/testsuite2igt -t $language/testsuite >> sample_out/t
./scripts/testsuite2igt $language/testsuite >> sample_out/igt
./igt2cfg sample_out/igt sample_out/t sample_out &>> log.tmp
svn update -r26117 &>> log.tmp
chmod +x scripts/*
echo $iso "SAO Prediction"
./infer-case count sample_out
echo "gold standard"
grep $iso ../data/infer-case_2017/gold_case.txt
echo
rm -rf sample_out; 
done; done
echo

echo "GRAM Method on Language Collage"
chmod +x scripts/*
declare -a directories='dev1 dev2 test new'
for dir in $directories; do
for language in ../data/567/$dir/*; do 
iso=$(basename "$language")
svn update -r38389 &>> log.tmp
mkdir sample_out
chmod +x scripts/*
./scripts/testsuite2igt -t $language/testsuite >> sample_out/t
./scripts/testsuite2igt $language/testsuite >> sample_out/igt
./igt2cfg sample_out/igt sample_out/t sample_out &>> log.tmp
svn update -r26117 &>> log.tmp
chmod +x scripts/*
echo $iso "GRAM Prediction"
./infer-case grams sample_out
echo "gold standard"
grep $iso ../data/infer-case_2017/gold_case.txt
echo
rm -rf sample_out; 
done; done

svn up &>> log.tmp