#!/bin/sh

test_gender()
{
echo Inferring gender in [$1/$2]...
mkdir -p $1
python3 ../../../src/scripts/infer-gender.py ../../../data/$1/$2/testsuite-enriched.xml > $1/$2-gender-choices.out
echo "  " Evaluating the gender produced...
python3 eval-gender.py $1/$2-gender-choices.out ../../../data/$1/$2/choices.up > $1/$2-eval.out
}

# make sure Python will be outputting in utf-8
export PYTHONIOENCODING=utf-8

# call test_gender with "data directory" "ISO code"
# e.g. to process: data/567/dev1/pbt/testsuite-enriched.xml
# use parameters: 567/dev1 pbt
test_gender 567/dev1 ang
test_gender 567/dev1 hau
test_gender 567/dev1 isl
test_gender 567/dev1 jpn
test_gender 567/dev1 jup
test_gender 567/dev1 mnk
test_gender 567/dev1 nan
test_gender 567/dev1 pbt
test_gender 567/dev1 rus
test_gender 567/dev1 sna

test_gender 567/dev2 bre
test_gender 567/dev2 cym
test_gender 567/dev2 fra
test_gender 567/dev2 lut
test_gender 567/dev2 mal
test_gender 567/dev2 ojg
test_gender 567/dev2 qub
test_gender 567/dev2 sci
test_gender 567/dev2 tam
test_gender 567/dev2 zul

test_gender 567/test ain
test_gender 567/test ary
test_gender 567/test ces
test_gender 567/test hbs
test_gender 567/test hix
test_gender 567/test inh
test_gender 567/test jaa
test_gender 567/test kat
test_gender 567/test tgl
test_gender 567/test tha
test_gender 567/test vie

#test_gender ctn/train ctn ctn/splits/xigt/clean/ctn-train-enriched.xml
